// JGameEx22b.java

import ch.aplu.jgamegrid.*;
import java.awt.*;

public class JGameEx22b extends GameGrid
  implements GGMouseTouchListener, GGMouseListener
{
  private Actor draggedPearl;

  public JGameEx22b()
  {
    super(8, 5, 80, Color.red, false);
    setTitle("Sort Pearls");
    addMouseListener(this, GGMouse.lDrag);
    for (int i = 0; i < 8; i++)
    {
      Actor pearl = new Actor("sprites/pearl.png");
      addActor(pearl, getRandomEmptyLocation());
      pearl.addMouseTouchListener(this, GGMouse.lPress | GGMouse.lRelease);
    }
    show();
    setSimulationPeriod(20);
    doRun();
  }

  public void act()
  {
    refresh();
  }

  public boolean mouseEvent(GGMouse mouse)
  {
    if (draggedPearl != null)
    {
      Point mousePos =
        new Point(mouse.getX(), mouse.getY());
      draggedPearl.setPixelLocation(mousePos);
    }
    refresh();
    return false;
  }

  public void mouseTouched(Actor actor, GGMouse mouse, Point spot)
  {
    switch (mouse.getEvent())
    {
      case GGMouse.lPress:
        draggedPearl = actor;
        break;
      case GGMouse.lRelease:
        if (draggedPearl != null)
        {
          draggedPearl.setLocationOffset(new Point(0, 0));
          draggedPearl = null;
        }
        break;
    }

  }

  public static void main(String[] args)
  {
    new JGameEx22b();
  }

}
